#!/bin/sh
# @(#$Id: rclman,v 1.2 2007-06-08 13:51:09 dockes Exp $  (C) 2004 J.F.Dockes
# Parts taken from Estraier:
#================================================================
# Estraier: a personal full-text search system
# Copyright (C) 2003-2004 Mikio Hirabayashi
#================================================================
#================================================================
# Process a manual page with groff and output html
# We'd like to use -Thtml, but this doesn't seem to be always available.
# So we use -Tutf8 and postprocess this to remove the ^H overstriking
#
#================================================================

# set variables
LANG=C ; export LANG
LC_ALL=C ; export LC_ALL
progname="rclman"
filetype=man

#RECFILTCOMMONCODE
##############################################################################
# !! Leave the previous line unmodified!! Code imported from the
# recfiltcommon file

# Utility code common to all shell filters. This could be sourced at run
# time, but it's slightly more efficient to include the code in the
# filters at build time (with a sed script).

# Describe error in a way that can be interpreted by our caller
senderror()
{
    echo RECFILTERROR $*
    # Also alert on stderr just in case
    echo ":2:$progname::: $*" 1>&2
    exit 1
}

iscmd()
{
    cmd=$1
    case $cmd in
    */*)
	if test -x $cmd -a ! -d $cmd ; then return 0; else return 1; fi ;;
    *)
      oldifs=$IFS; IFS=":"; set -- $PATH; IFS=$oldifs
      for d in $*;do test -x $d/$cmd -a ! -d $d/$cmd && return 0;done
      return 1 ;;
    esac
}

checkcmds()
{
    for cmd in $*;do
      if iscmd $cmd 
      then 
        a=1
      else 
        senderror HELPERNOTFOUND $cmd
      fi
    done
}

# show help message
if test $# -ne 1 -o "$1" = "--help" 
then
  echo "Convert a $filetype file to HTML text for Recoll indexing."
  echo "Usage: $progname [infile]"
  exit 1
fi

infile="$1"

# check the input file existence (may be '-' for stdin)
if test "X$infile" != X- -a ! -f "$infile"
then
  senderror INPUTNOSUCHFILE "$infile"
fi

# protect access to our temp files and directories
umask 77

##############################################################################
# !! Leave the following line unmodified !
#ENDRECFILTCOMMONCODE

checkcmds groff

# We need a temporary directory
if test z"$RECOLL_TMPDIR" != z; then
   ttdir=$RECOLL_TMPDIR
elif test z"$TMPDIR" != z ; then
   ttdir=$TMPDIR
else
   ttdir=/tmp
fi
tmpdir=$ttdir/rclman_tmp$$
mkdir $tmpdir || exit 1
mkdir $tmpdir/rclmantmp || exit 1

cleanup()
{
    # Note that we're using a constant part (rclmantmp), that hopefully
    # guarantees that we can't do big mistakes here.
    rm -rf $tmpdir/rclmantmp
    rmdir $tmpdir
}
    
trap cleanup EXIT HUP QUIT INT TERM

# Note: the qt preview really likes to find an <html> tag at the top
echo '<html>'

# Filter out some unwanted data when indexing
if test X$RECOLL_FILTER_FORPREVIEW = Xyes ; then
    (cd $tmpdir/rclmantmp; groff -man -Thtml) < "$infile"
else
   # When indexing we try to avoid adding terms for the section headers, which
   # are unfortunately somewhat ill defined. We eliminate rather loosely 
   # lines containing likely section header words preceded by a tag.
   (cd $tmpdir/rclmantmp; groff -mandoc -Thtml) < "$infile" | \
        egrep -v \
       '>NAME|>SYNOPSIS|>DESCRIPTION|>EXIT|>OPTIONS|>DIAGNOSTICS|>SUPPORTED HARDWARE|>CONFIGURATION|>AUTHOR|>BUGS|>REPORTING BUGS|>KNOWN BUGS|>COPYRIGHT|>SEE ALSO|>HISTORY|>ENVIRONMENT|>FILES'
fi


exit 0
